<?


if ($SETTINGS["dbtype"] == "ora") $SQLAS = "";

function mydb_create_database($database,$db = "") {
 global $DB, $SETTINGS;

 $db = ($db)?$db:$DB;
 if (!$db["type"]) $db["type"] = $SETTINGS["dbtype"];

 $query = "mydb_".$db["type"]."_create_database";
 return $query($database,$db["handle"]);
}


function mydb_connect($database, $server = "localhost", $login = "", $pw = "", $dbtype = "", $persistant = true, $halt = true, $autocommit=true, $charset="") {
 global $SETTINGS, $DB;

 if (is_array($database)) {
 $settings = $database;

 $database = $settings["db"];
 $server = $settings["server"];
 $dbtype = $settings["dbtype"];
 $autocommit = $settings["autocommit"];
 $charset = $settings["charset"];
 $persistant = $settings["persistant"];

 if ($settings["auto"]) {
 $rs = mydb_get_auto_login();
 $login = $rs["login"];
 $pw = $rs["pw"];
 } else {
 $login = $settings["login"];
 $pw = $settings["pw"];
 }
 }

 $dbtype = ($dbtype)?$dbtype:$SETTINGS["dbtype"];

 if (mydb_is_handle($DB)) {
 $persistant = $persistant && ($DB["db"] != $database);
 }
 
 $connect = "mydb_".$dbtype."_connect";
 $handle = array();
 $handle["handle"] = $connect($database, $server, $login, $pw, $persistant, $halt, $charset);
 if ($handle["handle"] === false) return false;
 
 $handle["db"] = $database;
 $handle["server"] = $server;
 $handle["login"] = $login;
 $handle["type"] = $dbtype;
 $handle["pw"] = $pw;
 $handle["persistant"] = $persistant;
 $handle["autocommit"] = $autocommit;
 $handle["rescount"] = 0;
 $handle["charset"] = $charset;
 return $handle;
}

function mydb_reconnect(&$handle) {
 $dbtype = $handle["type"];
 $connect = "mydb_".$dbtype."_connect";
 $handle["handle"] = $connect($handle["db"], $handle["server"], $handle["login"], $handle["pw"], $handle["persistant"], true, $handle["charset"]);
 $handle["rescount"] = 0;
}

function mydb_is_handle($db) {
 if (is_array($db) && $db["db"] && $db["handle"] && $db["type"]) {
 return true;
 } else {
 return false;
 }
}

function mydb_close($db = "") {
 global $DB, $SETTINGS;

 $db = ($db)?$db:$DB;
 if (!$db["type"]) $db["type"] = $SETTINGS["dbtype"];

 $close = "mydb_".$db["type"]."_close";
 $close($db["handle"]);

 return false;
}

function mydb_query($sql, $db = 0, $halt = true) {
 global $DB, $SETTINGS, $DEBUG;
 $db = ($db)?$db:$DB;
 if (!$db["type"]) $db["type"] = $SETTINGS["dbtype"];
 
 if ($DEBUG["echo"] && $DEBUG["perf"]) $t1 = microtime();
 
 $query = "mydb_".$db["type"]."_exec";
 $rs = array();
 
 $rs["rs"] = $query($sql, $db, $halt);
 $rs["count"] = 0;
 
 if ($DEBUG["echo"] && $DEBUG["perf"]) {
 $t2 = microtime();
 mydb_log_query($sql, $t1, $t2);
 }
 
 return ($rs["rs"])?$rs:false;
}

function mydb_fetch(&$rs, $db = 0, $way = MYSQL_BOTH) {
 global $DB, $SETTINGS;

 $db = ($db)?$db:$DB;
 if (!$db["type"]) $db["type"] = $SETTINGS["dbtype"];
 $fetch = "mydb_".$db["type"]."_fetch";
 return $fetch($rs["rs"], $way, $rs["count"]++);
}

function query($sql, $cache = false, $limit = 0, $db = 0, $way = MYSQL_BOTH, $bind = 0, $bindtype = 1) {
 global $DB, $SETTINGS, $DEBUG;

 if (is_array($cache)) {
 $db = $cache;
 $cache = false;
 }

 if (!$way) $way = MYSQL_BOTH;

 $db = ($db)?$db:$DB;
 if (!$db["type"]) $db["type"] = $SETTINGS["dbtype"];
 
 if (($DEBUG["echo"] && $DEBUG["perf"]) || $DEBUG["sql_perf"] ) $t1 = microtime();
 
 $query = "mydb_".$db["type"]."_query";

 
 $rs = $query($sql, $cache, $limit, $db, $way, $bind, $bindtype);
 
 if (($DEBUG["echo"] && $DEBUG["perf"]) || $DEBUG["sql_perf"] ) {
 $t2 = microtime();
 if ( $DEBUG["sql_perf"] )
 mydb_log_query_log($sql, $t1, $t2);
 if ( $DEBUG["echo"] && $DEBUG["perf"] ) 
 mydb_log_query($sql, $t1, $t2);
 }
 
 return $rs;
}

function mydb_log_query($sql, $t1, $t2, $cached = false) {
 global $DB_LOG;

 $key = md5($sql);

 if ($DB_LOG[$key]) {
 $rs = $DB_LOG[$key];
 } else {
 $rs = array();
 $rs["tot"] = 0;
 $rs["count"] = 0;
 $rs["cached"] = 0;
 $rs["sql"] = $sql;
 $rs["min"] = -1;
 $rs["max"] = 0;
 $rs["avg"] = 0;
 $rs["sum"] = 0;
 }
 
 $rs["tot"]++;
 if ($cached) {
 $rs["cached"]++;
 } else {
 $rs["count"]++;
 }
 $t = calctime($t1, $t2, 6);
 $rs["sum"] += $t;
 if ($rs["min"] < 0) $rs["min"] = $t; else $rs["min"] = min($rs["min"],$t);
 $rs["max"] = max($rs["max"],$t);
 $rs["avg"] = $rs["sum"] / $rs["count"];

 $DB_LOG[$key] = $rs;
}

function mydb_get_auto_login() {
 global $MYDB_AUTO_LOGIN;
 return $MYDB_AUTO_LOGIN;
}

function mydb_set_auto_login($login, $pw) {
 global $MYDB_AUTO_LOGIN;
 
 mysession_var_reg("MYDB_AUTO_LOGIN");
 $MYDB_AUTO_LOGIN = array("login"=>$login,"pw"=>$pw);
}

function mydb_log_query_log($sql, $t1, $t2) {
 global $DEBUG, $DB_IS_LOGGING, $TIME, $DO;
 
 if ( $DB_IS_LOGGING ) return;
 if ( $DEBUG["sql_perf"] )
 {
 $diff_ms = (int)(calctime($t1,$t2,3)*1000);
 if ( $diff_ms > $DEBUG["sql_perf"] )
 {
 if ( $DEBUG["echo"] ) {
 echo "bad performing query: ($diff_ms >".$DEBUG["sql_perf"].")<br>\n";
 echo "SQL: $sql<br>\n";
 }
 $DB_IS_LOGGING = true;
 $sql = "INSERT into logquery (timestamp,do,sql,total) VALUES (".
 sqlf_tl_num($TIME).", ".sqlf_tl_num($DO).", '".sqlslashes($sql)."', ".sqlf_tl_num($diff_ms).")";
 query( $sql );
 $DB_IS_LOGGING = false;
 }
 }
}

function mydb_print_query_log() {
 global $DB_LOG, $DEBUG;
 
 if (!$DEBUG["echo"] || !is_array($DB_LOG) ||!$DEBUG["perf"]) return "";

 $out = "";
 
 reset($DB_LOG);
 while (list($key,$val) = each($DB_LOG)) {
 $out .= $val["sql"]."<br>\n";
 $out .= "----<br>\n";
 $out .= "<table border=0 cellspacing=1 cellpadding=1>";
 $out .= "<tr><td>Total Count</td><td bgcolor=#f0f0f0> <b>".$val["tot"]."</b></td><td>Exec Count</td><td bgcolor=#f0f0f0> ".$val["count"]."</td><td>Cache Count</td><td bgcolor=#f0f0f0 colspan=3> <b>".$val["cached"]."</b></td></tr>\n";
 $out .= "<tr><td>Tot. Time</td><td bgcolor=#f0f0f0> <b>".$val["sum"]."</b></td><td>Min Time</td><td bgcolor=#f0f0f0> ".$val["min"]."</td><td>Max Time</td><td bgcolor=#f0f0f0> ".$val["max"]."</td><td>Avg Time</td><td bgcolor=#f0f0f0> <b>".$val["avg"]."</b></td></tr>\n";
 $out .= "</table>";
 $out .= "<br>\n";
 }
 
 return $out;
}




function parse_jdbc_url($url) {

}
?>
