<?php








class DefaultValueComponent extends CollectionComponent
{
 function DefaultValueComponent( &$component, $defaultValue = '', $defaultLabel = '')
 {
 parent::CollectionComponent();
 $this->setComponent( 'c', $component );
 $this->setButtonLabel($defaultLabel);

 $this->setDefaultValue( $defaultValue );
 }
 
 function setButtonLabel($label = '') {
 if (!$label) $label = i18n('Default Value');
 $this->d_values['buttonLabel'] = i18n($label);
 }

 function setDefaultValueObject( $obj ) {
 $this->d_values['defaultValue'] = $obj;
 }

 function setDefaultValue( $data ) {
 $c = $this->getBaseComponent();

 if ( is_a($c, 'selectcomponent') ) {
 $this->setDefaultValueObject( array($data) );
 } else {
 $this->setDefaultValueObject( new StringObject( $data ) );
 }
 }
 
 function &getBaseComponent()
 {
 return $this->getComponent( 'c' );
 }

 function resolveAction( &$form, &$action ) {
 if ($action->getName() == 'reset') {
 $c =& $this->getComponent( 'c' );
 if ( is_a($c, 'selectcomponent') ) {
 $c->setSelection( $this->d_values['defaultValue'] );
 } else {
 $c->setObject( $this->d_values['defaultValue'] );
 }
 }
 }

 function _getButtonHtml( &$form, $key ) {
 $resetAction = $form->getJsActionCall( new ComponentResolvableFormAction( $key, 'reset' ) );

 node_class( 'skeletonfactory' );
 $skel = SkeletonFactory::getSkeleton();
 $label = $this->d_values['buttonLabel'];
 return $skel->parseTemplate( 'dialog.button', array('name'=>'resetValue',
 'text'=>$label, 'text_urlenc'=>urlencode($label),
 'submit_func'=>$resetAction) );
 }

 function getHTML( &$form, $prefix, $doCheck, $checkSeverity, $key )
 {
 global $ICO_BACK;

 $c = &$this->getComponent('c');
 $comp = $this->_getComponentHTML( 'c', $form, $prefix, $doCheck, $checkSeverity, $key );
 
 foreach ( $comp as $cKey=>$cHTML )
 {
 if (is_array($cHTML)) {
 $cLabel = $cHTML[0];
 $cHTML = $cHTML[1];
 } else {
 $cLabel = NULL;
 }
 if (!$cHTML) continue;

 $bHTML = $this->_getButtonHtml($form, $key);
 $comp[$cKey] = array($cLabel, "<table width=\"100%\" border=0 cellpadding=0 cellspacing=0><tr><td>$cHTML</td><td width=\"5\">&nbsp;</td><td align=\"right\">$bHTML</td></tr></table>");
 }

 return $this->mergeResult( parent::getHTML( $form, $prefix, $doCheck, $checkSeverity, $key ), $comp );
 }
}

class GlobalDefaultValueComponent extends DefaultValueComponent
{
 function resolveAction( &$form, &$action ) {
 $props = $form->getPropertyNames();
 foreach( $props as $key ) {
 $c = $form->getComponent( $key );
 if ( is_a($c, 'defaultValueComponent') && !is_a($c, 'globaldefaultvaluecomponent') ) {
 echo "-> $key<br>";
 $c->resolveAction( $form, $action );
 }
 }
 }
}

?>
