<?php
GUIFactory::setMainGUI( "main" );
load_menu( 862, $T_TASK, 0, i18n('new') );

$main =& GUIFactory::getMainGUI();
$main->includeJS( "hiselector" );

node_include( "htmlformwizard" );


class DupNameChecker extends FormChecker
{
 function check( &$form )
 {
 global $DIC;
 $comp =& $form->getComponent( "name" );
 $name = $comp->getText();
 $taskTable = new SqlTable( "task" );
 $results = $taskTable->findBy( "name", $name, "like" );
 if ( count( $results ) )
 {
 $comp->addError( new NodeException( i18n('sn_task_duplicate') ) );
 }
 }
}


class TaskNewBuilder extends WizardBuilder
{
 var $m_lastTemplateId = -1;
 
 function createStep1( &$wizard, &$form )
 {
 global $DIC, $ICO_TREEMENU;
 node_class("selectcomponent");
 node_class("textcomponent");
 
 $tplTable = new SqlTable( "tasktemplate" );
 $templates = $tplTable->findAll();
 $list = array();
 foreach ( $templates as $template )
 {
 $list[$template->getValue("id")] = $template->getValue("name");
 }
 $c = &new TextComponent( i18n('sn_name'), TRUE, "", REG_NOTEMPTY );
 $form->addComponent( "name", $c );
 $form->addComponent( "tpl", new SelectComponent( i18n('sn_task_template'), $list ) );
 $form->addCustomCheck( new DupNameChecker() );
 $form->setHeader( i18n('sn_task_create'), $ICO_TREEMENU ); 
 }
 
 function _createComponents( $templateId, $initSelectors=TRUE )
 {
 $joinTable = new SqlJoinTable( array( new SqlTable( "tasktemplate" ), new SqlTable( "tasktemplateparam" ) ),
 array( "tasktemplateparam.tasktemplate_id=tasktemplate.id" ) );
 $result = $joinTable->findBy( "tasktemplate.id", $templateId );
 $ret = array();
 if ( count( $result ) > 0 )
 {
 foreach ( $result as $r )
 {
 $param = $r["tasktemplateparam"];
 $pName = $param->getValue("id");
 if ( $initSelectors )
 $ret[$pName] = &initSelector( $param->getValue("paramtype"), $param->getValue("name") );
 else
 $ret[] = $pName;

 } 
 }
 return $ret;
 }
 
 function createStep2( &$wizard, &$form )
 {
 global $DIC, $ICO_TREEMENU;
 
 $step1 =& $wizard->getStep( 1 );
 $comp =& $step1->getComponent( "tpl" );
 $templateId = $comp->getSelection();
 unset($comp);
 $comp =& $step1->getComponent( "name" );
 $name = $comp->getText();
 unset($comp);
 
 $this->m_lastTemplateId = $templateId;
 
 $joinTable = new SqlJoinTable( array( new SqlTable( "tasktemplate" ), new SqlTable( "tasktemplateparam" ) ),
 array( "tasktemplateparam.tasktemplate_id=tasktemplate.id" ) );
 $result = $joinTable->findBy( "tasktemplate.id", $templateId );
 $taskParams = $this->_createComponents($templateId);
 foreach ( $taskParams as $key=>$nothing )
 {
 $form->addComponent( $key, $taskParams[$key] );
 }
 $form->setHeader( i18n('sn_parameter_fill'), $ICO_TREEMENU );
 
 }
 
 function updateStep( &$wizard, $stepNr, &$form ) 
 {
 if ( $stepNr == 2 )
 {
 $step1 = $wizard->getStep( 1 );
 $comp =& $step1->getComponent( "tpl" );
 $templateId = $comp->getSelection();
 if ( $templateId != $this->m_lastTemplateId )
 {
 $form->clear();
 $this->createStep2( $wizard, $form );
 }
 }
 }
 
 function createStep( &$wizard, $stepNr, &$form ) 
 {
 switch ( $stepNr )
 {
 case 1:
 $this->createStep1( $wizard, $form );
 break;
 case 2:
 $this->createStep2( $wizard, $form );
 break;
 }
 }
 
 function cancel( &$wizard ) {
 global $REDO;
 $REDO = 860;
 }
 
 function done( &$wizard )
 {
 global $REDO, $USER_ID;

 $step1 =& $wizard->getStep( 1 );
 $comp =& $step1->getComponent( "name" );
 $name = $comp->getText();

 unset($comp);
 $comp =& $step1->getComponent( "tpl" );
 $templateId = $comp->getSingleSelection();
 $step2 =& $wizard->getStep( 2 );

 $task = new SqlTableRow( new SqlTable( "task" ) );
 $task->setValue( "name", $name );
 $task->setValue( "tasktemplate_id", $templateId );
 $task->setValue( "editor", $USER_ID );
 $task->setValue( "edate", time() );
 $task->setValue( "creator", $USER_ID );
 $task->setValue( "cdate", time() );
 $task->save();
 $iid = $task->getInsertId();
 $tpTable = new SqlTable("taskparam");
 $taskParams = $this->_createComponents($templateId, FALSE);
 foreach ( $taskParams as $id )
 {
 
 $param = &$step2->getComponent( $id );
 $fields = array_keys($param->getFields(true));
 foreach ( $fields as $field )
 {
 $row = new SqlTableRow( $tpTable );
 $row->setValue( "task_id", $iid );
 $row->setValue( "templateparam_id", $id );
 $row->setValue( "name", $field );
 if ( is_a( $param, "collectioncomponent" ) )
 {
 
 $row->setValue( "value", $param->resolveFieldValue($field) );
 }
 else
 $row->setValue( "value", $param->getFieldValue($field) );
 $row->save();
 }
 }
 $REDO = 860;
 }
}

$NODE_CLASS["tasknewbuilder"] = FALSE;

$form = new HtmlFormWizard( "mywizard" );
if ( $form->isNew() )
{
 $form->setBuilder( new TaskNewBuilder(), 2 );
 $form->setHeader( "Wizard-Demo", $ICO_ROOT );
}



?>
