<?
GUIFactory::setMainGUI( "main" );
node_class( "htmlform3" );
node_class( "datecomponent" );
node_class( "selectcomponent" );
node_class( "checkboxcomponent" );
node_class( "labelcomponent" );

if (!perm($USER_ID, T_DEVTOOLS, '', 7)) {
 halt(7, "Permission denied!");
}






function calcPhpStats( $startTS, $endTS, $interval, $doSidCheck ) 
{ 
 node_include("cmd_desc");
 global $W_LOGIN, $W_LOGOUT;
 
 
 $sql = "SELECT cmd_desc_id, SUBSTRING(info FROM 5 FOR 15) sid, o_id2 time FROM logcmd WHERE o_id2 >= ".sqlf_value($startTS)." AND o_id2 <= ".sqlf_value($endTS)." 
	    AND cmd_desc_id IN (".sqlf_tl_num($W_LOGIN).",".sqlf_tl_num($W_LOGOUT).") AND o_id != -1 ORDER BY o_id2,timestamp";
 $rs = query($sql);

 $num = 0;
 $time = $startTS;
 $max = array($time=>0);
 $ovmax = 0;
 $sids = array();
 
 
 foreach ($rs["arr"] as $row) {
 $cmd = $row["cmd_desc_id"];
 $sid = $row["sid"];
 
 while ( $time + $interval < $row["time"] ) {
 $time += $interval;
 $max[$time] = 0;
 }
 
 if ( $cmd == $W_LOGIN ) {
 $num++;

 
 $max[$time] = max($max[$time], $num);
 $ovmax = max($ovmax,$num);

 if ( $doSidCheck ) {
 $sids[$sid] = $row["time"];
 }
 
 } else if ( $cmd == $W_LOGOUT ) {
 
 if ( $doSidCheck ) {
 if ( ! $sids[$sid] ) {
 continue;
 } else {
 
 unset($sids[$sid]);
 }
 }
 
 $num--;
 }
 }

 $out = "
Start time: $startTS, End time: $endTS, Interval: $interval <br>
Number of open sessions at end-time: $num <br>
Overall max sessions: $ovmax <br>
Max Sessions per interval: <br>
<table cellspacing=2>";
 foreach ($max as $time=>$cnt) {
 $out .= "<tr><td>".date("d.m.Y", $time)."</td><td>$cnt</td><tr>";
 }
 $out .= "</table>";


 return $out;
}





function calcSqlStats( $startTS, $endTS, $interval ) 
{
 node_include("cmd_desc");
 global $W_LOGIN, $W_LOGOUT;
 
 
 
 $sql1 = "DROP TABLE IF EXISTS tmpuserstat, tmpuserstatint, tmpuserstatlog";
 
 $sql2 = "CREATE TABLE tmpuserstat (id INT NOT NULL PRIMARY KEY, cmd INT NOT NULL, time INT NOT NULL, sid CHAR(15), 
	    INDEX (time), INDEX(sid), INDEX(cmd))";
 
 $sql3 = "INSERT INTO tmpuserstat (id, cmd, time, sid) 
	    SELECT id, cmd_desc_id, o_id2, SUBSTRING(info FROM 5 FOR 15) sid FROM logcmd WHERE cmd_desc_id IN ($W_LOGIN,$W_LOGOUT) 
	        AND o_id2 >= $startTS AND o_id2 <= $endTS AND o_id != -1";
 
 $sql4 = "CREATE TABLE tmpuserstatint (start INT NOT NULL, end INT NOT NULL, INDEX(start), INDEX(end))";
 
 $sql5 = "INSERT INTO tmpuserstatint (start,end) VALUES ($startTS,".($startTS+$interval).")";
 $start = $startTS+$interval;
 while ($start < $endTS) {
 $sql5 .= ",($start,";
 $start += $interval;
 $sql5 .= "$start)";
 }
 
 $sql6 = "CREATE TABLE tmpuserstatlog SELECT logins.time, COUNT(*) c FROM tmpuserstat logins
	INNER JOIN tmpuserstat alogin ON logins.cmd = $W_LOGIN AND alogin.cmd = $W_LOGIN AND alogin.time <= logins.time
	INNER JOIN tmpuserstat alogout ON alogout.cmd = $W_LOGOUT AND alogin.sid = alogout.sid AND alogout.time >= logins.time
GROUP BY logins.id, logins.time";
 
 $sql7 = "
SELECT FROM_UNIXTIME(tint.start) start, IFNULL(MAX(active.c),0) max FROM 
   tmpuserstatint tint LEFT JOIN 
   tmpuserstatlog active ON active.time >= tint.start AND active.time < tint.end 
GROUP BY tint.start";
 
 
 
 











 
 













 
 $max = $rs["arr"];
 
 
 
 $sql = $sql1.";\n".$sql2.";\n".$sql3.";\n".$sql4.";\n".$sql5.";\n".$sql6.";\n".$sql7.";\n".$sql1;
 
 $out = "SQL max number of sessions: <br>";
 if ( !$max ) {
 $out .= i18n("buggy mysql-driver, please run stmt manually");
 } else {
 $out .= "<table>";
 foreach ($max as $row) {
 $out .= "<tr><td>".$row["start"]."</td><td>".$row["max"]."</td></tr>\n";
 }
 $out .= "</table>";
 }
 $out .= "SQL: <pre>".str_replace("\t", "        ",$sql)."</pre><br>";
 
 return $out;
}

function onStartStat( &$form, $param )
{
 
 $start =& $form->getComponent( "start" );
 $end =& $form->getComponent( "end" );
 $interval =& $form->getComponent( "interval" );
 $sidcheck =& $form->getComponent( "sidcheck" );
 
 
 $startTS = $start->getTimestamp();
 $endTS = $end->getTimestamp();
 $doSidCheck = $sidcheck->isChecked();
 
 $startTS = mktime( 0, 0, 0, date("m",$startTS), date("d",$startTS), date("Y",$startTS) );
 $endTS = mktime( 23, 59, 59, date("m",$endTS), date("d",$endTS), date("Y",$endTS) );
 
 if ($startTS < mktime( 0, 0, 0, 9, 14, 2007 )) {
 $start->addError(new NodeException(i18n("Warning: Logs before 14.9.2007 may not be accurate.")));
 }
 
 
 $out = "";
 $out .= calcPhpStats( $startTS, $endTS, $interval->getSingleSelection(), $doSidCheck );
 $out .= "<br/><hr/>";
 $out .= calcSqlStats( $startTS, $endTS, $interval->getSingleSelection() );

 global $OUT;
 $OUT .= $out;
 
}

$OUT = "Beware of the following restriction: <br>Sessions are not accounted if they: are not yet marked as expired, 
    have been started before the interval, are not closed at the end of the interval (sql only), are anonymous sessions.<br/><br/><hr/>";

$form = new HtmlForm3( "userstat" );
if ( $form->isNew() )
{
 $form->setHeader(i18n("User session statistics"), $ICO_FOLDER);

 $intervals = array( 86400=>i18n("Day"), 86400*7=>i18n("Week"), 86400*31=>i18n("Month") );
 
 $form->addComponent( "start", new DateComponent(i18n("Startdate:"), $TIME - 86400*7, DCP_DATE) );
 $form->addComponent( "end", new DateComponent(i18n("Enddate:"), $TIME, DCP_DATE) );
 $form->addComponent( "interval", new SelectComponent(i18n("Interval:"), $intervals, 86400 ) );
 $form->addComponent( "sidcheck", new CheckboxComponent(i18n("Use session match:"), true) );
 

 $form->addButton( "ok", new Button( i18n( "OK" ) ), new SimpleFormAction( "onStartStat" ), TRUE );
}

?>
